<id>
Showcase Poll for YaBB 2.2
</id>

<version>
1.3
</version>

<mod info>
Description:
=============

"Showcase's" a poll selected by the Admins and Gmods to be displayed on the Board Index page.

Showcase a Poll by clicking "Showcase Poll?" in Title Bar of existing polls (Admin and Gmods only).

Remove the current "Showcase Poll" by clicking "Remove Showcase Poll?" in Title Bar 
of the currently showcased poll on the Board Index page (Admin and Gmods only).

Current "Showcase Poll's" are designated in the thread display page of the poll which is the 
current "Showcase Poll" with "Currently Being Showcased" in the Title Bar of 
the Poll (visible to all users).

Link to the Thread of which the Showcase Poll is associated is provided.

If a Poll that is currently being "Showcased", is in a thread that resides in a Category 
for which the Guest or Member does not have access to, then the "Showcase Poll" will 
not be displayed to that Guest or Member on the Board Index page.

Installation:
1) Modify YaBB files using BoardMod or manually.
2) Load modified files to your server in ASCII mode. 

Languages/English.Menu.lng (ASCII)
Languages/English/Poll.lng (ASCII)
Sources/BoardIndex.pl (ASCII)
Sources/ModifyMessage.pl (ASCII)
Sources/MoveTopic.pl (ASCII)
Sources/Poll.pl (ASCII)
Sources/SubList.pl (ASCII)
Variables/Menu0.def (ASCII)
Variables/Menu1.def (ASCII)
Variables/Menu2.def (ASCII)

Mod History:
Status Showcase Poll V1.3 (January 22 2008)
- Fix Moderator modify Poll Access

Status Showcase Poll V1.2 (December 09 2007)
- updated for YaBB 2.2

Status Showcase Poll V1.1 (January 13 2007)
- optimize check for Board permission and add check for Category permission
- Add BoardPass Compatible modfile

Status Showcase Poll V1.0 (January 12 2007)
- First release

Credits:
Original Mod: Showcase Poll
code by Dummy Proof

Updated for YaBB 2.1 "Showcase Poll" by:
Boris Tjuvanov (MF-B) - http://yabb.xost.ru
Jeffrey Man (Jet Li) - http://www.grafix-world.nl

Graphic:
JetLi - http://www.grafix-world.nl
</mod info>

<author>
Boris Tjuvanov (MF-B) and Jeffrey Man (Jet Li)
</author>

<homepage>
http://yabb.xost.ru/ and http://www.grafix-world.nl
</homepage>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$ShowcasePoll = "Showcase_Poll|Boris Tjuvanov (<a href=\"http://www.mf-b.ru\" target=\"_blank\">MF-B</a>) and Jeffrey Man (<a href=\"http://www.grafix-world.nl\" target=\"_blank\">Jet Li</a>)|Showcase a Poll selected by the Admins and Gmods to be displayed on the BoardIndex page.<br /><br /><span class=\"small\"><b>Credits:</b> original mod (YaBB 1.xx) by 'Dummy Proof'</span>|1.3|January 22th, 2008|";
	push (@installed_mods, "$ShowcasePoll");
</add before>

<edit file>
Languages/English/Menu.lng
</edit file>

<search for>
'33' => 'View Votes',
</search for>

<add after>
'33a' => 'View Thread',
</add after>

<edit file>
Languages/English/Poll.lng
</edit file>

<search for>
1;
</search for>

<add before>
%scpolltxt = (
'2' => 'Remove Showcase Poll?',
'3' => 'Currently Being Showcased',
'4' => 'Showcase Poll?',
);

</add before>

<edit file>
Sources/BoardIndex.pl
</edit file>

<search for>
	&getlog(@goodboards);
</search for>

<add after>
########showcase poll start
$polltemp = '';
if (-e "$datadir/showcase.poll") {
	fopen (SCPOLLFILE, "$datadir/showcase.poll");
	@showdata = <SCPOLLFILE>;
	fclose (SCPOLLFILE);
	$showcasepoll = $showdata[0];
	$showcasepoll =~ s~\n~~g;
	my ($scboard, $scviewnum) = split(/\|/, $showcasepoll);
	chomp $scboard;
	
	# Look for a valid poll file.
	if (-e "$datadir/$scviewnum.poll") {
		$pollthread = 1;
		my $curcat = ${$uid.$scboard}{'cat'};
		my $catperms = (split /\|/,$catinfo{$curcat})[1];
		my $access = &CatAccess($catperms);
		if (!$access) { $pollthread = 0; }
		my $boardperms = (split /\|/,$board{$scboard})[1];
		$access = &AccessCheck($scboard, '', $boardperms);
		if (!$iamadmin && $access ne 'granted') { $pollthread = 0; }
	}

	if ($pollthread) { 
		$polltemp = qq~<script language="JavaScript1.2" src="$ubbcjspath" type="text/javascript"></script>~;
		require "$sourcedir/Poll.pl"; &display_poll($scviewnum,1);
		$polltemp .= $pollmain;
	 }
}
#########showcase poll end

</add after>

<search for>
	$boardindex_template =~ s/({|<)yabb navigation(}|>)/&nbsp;/g;
</search for>

<add after>
	$boardindex_template =~ s/({|<)yabb pollshowcase(}|>)/$polltemp/g;
</add after>

<edit file>
Sources/ModifyMessage.pl
</edit file>

<search for>
			unlink("$datadir/$threadid.poll");
			unlink("$datadir/$threadid.polled");
</search for>

<add before>
			########showcase poll start
			# Look for a showcase.poll file to unlink.
			if (-e "$datadir/showcase.poll") {
				my ($board, $viewnum);
				fopen (FILE, "$datadir/showcase.poll");
				@showdata = <FILE>;
				fclose (FILE);
				$showcasepoll = $showdata[0];
				$showcasepoll =~ s~\n~~g;
				($scboard, $viewnum) = split(/\|/, $showcasepoll);
				if ($viewnum == $threadid) {unlink ("$datadir/showcase.poll");}
			}
			#########showcase poll end
</add before>

<edit file>
Sources/MoveTopic.pl
</edit file>

<search for>
	&BoardSetLastInfo($toboard);
</search for>

<add after>
	if (-e "$datadir/showcase.poll") {
		fopen (FILE, "$datadir/showcase.poll");
		@showdata = <FILE>;
		fclose (FILE);
		$showcasepoll = $showdata[0];
		$showcasepoll =~ s~\n~~g;
		($scboard, $scviewnum) = split(/\|/, $showcasepoll);
		if ($scviewnum eq $thread) {
			fopen (FILE, ">$datadir/showcase.poll");
			print FILE "$toboard|$thread";
			fclose (FILE);
		}
	}
</add after>

<edit file>
Sources/Poll.pl
</edit file>

<search for>
sub DoVote {
	$pollnum = $INFO{'num'};
	$start   = $INFO{'start'};
</search for>

<add after>
	$scpoll = $INFO{'scp'};
</add after>

<search for>
	fopen(FILE, ">$datadir/$pollnum.polled");
	print FILE "$user_ip|$username|$vote|$date\n";
	print FILE @polled;
	fclose(FILE);

	if ($start) { $start = "/$start"; }
	$yySetLocation = qq~$scripturl?num=$pollnum$start~;
</search for>

<replace>
	fopen(FILE, ">$datadir/$pollnum.polled");
	print FILE "$user_ip|$username|$vote|$date\n";
	print FILE @polled;
	fclose(FILE);
			
	if ($start) { $start = ";start=$start"; }
	if ($scpoll == 1){
		$yySetLocation = qq~$scripturl~;
	} else {
		$yySetLocation = qq~$scripturl?num=$pollnum$start~;
	}
</replace>

<search for>
sub UndoVote {
	$pollnum = $INFO{'num'};
</search for>

<add after>
	$scpoll = $INFO{'scp'};
</add after>

<search for>
	fopen(FILE, ">$datadir/$pollnum.polled");
	print FILE @polled;
	fclose(FILE);

	if ($start) { $start = "/$start"; }
	$yySetLocation = qq~$scripturl?num=$pollnum$start~;
</search for>

<replace>
	fopen(FILE, ">$datadir/$pollnum.polled");
	print FILE @polled;
	fclose(FILE);
			
	if ($start) { $start = ";start=$start"; }
	if ($scpoll == 1){
		$yySetLocation = qq~$scripturl~;
	} else {
		$yySetLocation = qq~$scripturl?num=$pollnum$start~;
	}
</replace>

<search for>
sub LockPoll {
	$pollnum = $INFO{'num'};
</search for>

<add after>
	$scpoll = $INFO{'scp'};
</add after>

<search for>
	fopen(FILE, ">$datadir/$pollnum.poll");
	print FILE "$poll_question|$poll_locked|$poll_uname|$poll_stuff\n";
	print FILE @poll_data;
	fclose(FILE);

	if ($start) { $start = "/$start"; }
	$yySetLocation = qq~$scripturl?num=$pollnum$start~;
</search for>

<replace>
	fopen(FILE, ">$datadir/$pollnum.poll");
	print FILE "$poll_question|$poll_locked|$poll_uname|$poll_stuff\n";
	print FILE @poll_data;
	fclose(FILE);

	if ($start) { $start = ";start=$start"; }
	if ($scpoll == 1){
		$yySetLocation = qq~$scripturl~;
	} else {
		$yySetLocation = qq~$scripturl?num=$pollnum$start~;
	}
</replace>

<search for>
sub display_poll {
	$pollnum = @_[0];
</search for>

<add after>
########showcase poll
	$brdpoll = @_[1];
	$scp = '';
	$vthread = '';
	$boardpoll = '';
	$pollboard = '';
	if($brdpoll){
		$scp = qq~;scp=$brdpoll~;
		$vthread = qq~<a href="$scripturl?num=$pollnum" class="altlink">$img{'viewthread'}</a>$menusep~;
	}

# Look for a showcase.poll file.
if (-e "$datadir/showcase.poll") {
	fopen (FILE, "$datadir/showcase.poll");
		@showdata = <FILE>;
	fclose (FILE);
	$showcasepoll = $showdata[0];
	$showcasepoll =~ s~\n~~g;
	($scboard, $scviewnum) = split(/\|/, $showcasepoll);
}
	if ($scviewnum == $pollnum && ( $brdpoll != 1 )){
		$boardpoll = qq~&nbsp;/&nbsp;<i>$scpolltxt{'3'}</i>~;
	}
	$pollboard = $currentboard || $scboard; 
	if ($iamadmin || $iamgmod) {
		if ($scviewnum != $pollnum && ( $brdpoll != 1 )) {
			$boardpoll = qq~&nbsp;/&nbsp;<a href="$scripturl?action=scpoll;board=$pollboard;num=$pollnum" class="altlink">$scpolltxt{'4'}</a>~;
		} elsif ($scviewnum == $pollnum && ( $brdpoll == 1 )){
			$boardpoll = qq~&nbsp;/&nbsp;<a href="$scripturl?action=scpolldel" class="altlink">$scpolltxt{'2'}</a>~;
		}
	}
########showcase poll
</add after>

<search for>
		if ($poll_locked) {
			$lockpoll = qq~<a href="$scripturl?action=lockpoll;num=$pollnum" class="altlink">$img{'openpoll'}</a>~;
		} else {
			$lockpoll = qq~<a href="$scripturl?action=lockpoll;num=$pollnum" class="altlink">$img{'closepoll'}</a>~;
		}
		$modifypoll = qq~$menusep<a href="$scripturl?board=$currentboard;action=modify;message=Poll;thread=$pollnum" class="altlink">$img{'modifypoll'}</a>~;
		$deletepoll = qq~$menusep<a href="javascript:document.removepoll.submit();" class="altlink" onclick="return confirm('$polltxt{'44'}')">$img{'deletepoll'}</a>~;
		if ($iamadmin) { $displayvoters = qq~<a href="$scripturl?action=showvoters;num=$pollnum">$img{'viewvotes'}</a>~; }
		if ($hide_results) {
</search for>

<replace>
		if ($poll_locked) {
			$lockpoll = qq~<a href="$scripturl?action=lockpoll;num=$pollnum$scp" class="altlink">$img{'openpoll'}</a>~;
		} else {
			$lockpoll = qq~<a href="$scripturl?action=lockpoll;num=$pollnum$scp" class="altlink">$img{'closepoll'}</a>~;
		}
		$modifypoll = qq~$menusep<a href="$scripturl?board=$pollboard;action=modify;message=Poll;thread=$pollnum" class="altlink">$img{'modifypoll'}</a>~;
		$deletepoll = qq~$menusep<a href="javascript:document.removepoll.submit();" class="altlink" onclick="return confirm('$polltxt{'44'}')">$img{'deletepoll'}</a>~;
		if ($iamadmin) { $displayvoters = qq~<a href="$scripturl?action=showvoters;num=$pollnum">$img{'viewvotes'}</a>~; }
		if ($hide_results) {
</replace>

<search for>
		$deletevote = qq~<a href="$scripturl?action=undovote;num=$pollnum">$img{'deletevote'}</a>~;
</search for>

<replace>
		$deletevote = qq~<a href="$scripturl?action=undovote;num=$pollnum$scp">$img{'deletevote'}</a>~;
</replace>

<search for>
     <td class="titlebg" valign="middle" align="left">
		<div style="float: left; width: 50%; text-align: left;">
			<span class="text1">$poll_icon <b>$polltxt{'15'}</b></span>
		</div>
		<div style="float: left; width: 50%; text-align: right;">
			<span class="small">$lockpoll$modifypoll$deletepoll</span>
		</div>
	</td>
</search for>

<replace>
     <td class="titlebg" valign="middle" align="left">
		<div style="float: left; width: 50%; text-align: left;">
			<span class="text1">$poll_icon <b>$polltxt{'15'}</b>$boardpoll</span>
		</div>
		<div style="float: left; width: 50%; text-align: right;">
			<span class="small">$lockpoll$modifypoll$deletepoll</span>
		</div>
	</td>
</replace>

<search for>
<form name="poll" method="post" action="$scripturl?action=vote;num=$pollnum" style="display: inline;">
</search for>

<replace>
<form name="poll" method="post" action="$scripturl?action=vote;num=$pollnum$scp" style="display: inline;">
</replace>

<search for>
            <span class="small">$deletevote$displayvoters</span>
</search for>

<replace>
            <span class="small">$vthread$deletevote$displayvoters</span>
</replace>

<search for>
1;
</search for>

<add before>
sub ShowcasePoll {
	my $brdid = $INFO{'board'};
	my $thrdid = $INFO{'num'};
	fopen (SCFILE, ">$datadir/showcase.poll");
	print SCFILE "$brdid|$thrdid";
	fclose (SCFILE);
	$yySetLocation = qq~$scripturl~;
	&redirectexit;
	exit;
}

sub DelShowcasePoll{
	if (-e "$datadir/showcase.poll") { unlink("$datadir/showcase.poll"); }
	$yySetLocation = qq~$scripturl~;
	&redirectexit;
	exit;
}

</add before>

<edit file>
Sources/SubList.pl
</edit file>

<search for>
'vote',"Poll.pl&DoVote",
</search for>

<add after>
'scpoll',"Poll.pl&ShowcasePoll",
'scpolldel',"Poll.pl&DelShowcasePoll",
</add after>

<edit file>
Templates/default/BoardIndex.template
</edit file>

<search for>
<!-- Board Index Category block start, should be left as is -->
</search for>

<add before>
<!-- Board Index Showcase Poll start -->

{yabb pollshowcase}<br />

<!-- Board Index Showcase Poll end-->

</add before>

<edit file>
Templates/yabb21/BoardIndex.template
</edit file>

<search for>
<!-- Navigation Bar end -->

</search for>

<add after>
<!-- Board Index Showcase Poll start -->

<yabb pollshowcase><br />

<!-- Board Index Showcase Poll end-->

</add after>

<edit file>
Variables/Menu0.def
</edit file>

<search for>
'viewvotes' => "<img src=\"$imagesdir/poll_vvote.$imgext\" alt=\"$img_polltxt{'33'}\" border=\"0\" /> <span class=\"imgwindowbg\">$img_polltxt{'33'}</span>",
</search for>

<add after>
'viewthread' => "<img src=\"$imagesdir/thread.$imgext\" alt=\"$img_polltxt{'33a'}\" border=\"0\" /> <span class=\"imgwindowbg\">$img_polltxt{'33a'}</span>",
</add after>

<edit file>
Variables/Menu1.def
</edit file>

<search for>
'viewvotes' => "$img_polltxt{'33'}",
</search for>

<add after>
'viewthread'  => "$img_polltxt{'33a'}",
</add after>

<edit file>
Variables/Menu2.def
</edit file>

<search for>
'viewvotes' => "<img src=\"$html_root/Buttons/$button_language/poll_vvote.$imgext\" alt=\"$img_polltxt{'33'}\" border=\"0\" />",
</search for>

<add after>
'viewthread' => "<img src=\"$html_root/Buttons/$button_language/thread.$imgext\" alt=\"$img_polltxt{'33a'}\" border=\"0\" />",
</add after>